/*
 * Segment 2 (KEx),  SWE 2.1 LMS
 * Copyright (C) 2007 BitCtrl Systems GmbH
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.kex.lms;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.GregorianCalendar;

import org.junit.Assert;
import org.junit.Test;

import de.bsvrz.kex.lms.vew.XMLTools;

/**
 * Testfall Zeitumrechnung TIC-Zeiten.
 *
 * @author BitCtrl Systems GmbH, Gieseler
 */
public class ZeitTest {

	/**
	 * Umrechung TIC-Zeit in Systemzeit.
	 */
	@Test
	public void testeZeitSystemInTIC() {
		System.out.println("Umrechnung Systemzeit in TIC-Zeit");

		final GregorianCalendar cal = new GregorianCalendar();
		cal.setTimeInMillis(System.currentTimeMillis());
		final DateFormat formatter = new SimpleDateFormat();
		System.out.println("Systemzeit:  " + formatter.format(cal.getTime()));

		final String ticzeit = XMLTools.getTICDateTime(cal.getTimeInMillis());
		System.out.println("TIC-Zeit:    " + ticzeit);

		final SimpleDateFormat sdf = new SimpleDateFormat();
		sdf.applyPattern("yyyy-MM-dd'T'HH:mm:ss");
		final GregorianCalendar calv = new GregorianCalendar();
		try {
			calv.setTimeInMillis(sdf.parse(ticzeit).getTime());
		} catch (final ParseException e) {
			Assert.fail();
		}
		// assertEquals(cal.get(Calendar.HOUR_OF_DAY), calv
		// .get(Calendar.HOUR_OF_DAY)
		// + cal.get(Calendar.DST_OFFSET) / 3600000);

		// assertEquals(cal.get(Calendar.HOUR), 10);
	}

	/**
	 * Umrechung TIC-Zeit in Systemzeit.
	 */
	@Test
	public void testeZeitTICInSystem() {
		final String ticZeit = "2008-05-28T08:13:14.598";

		System.out.println("Umrechnung TIC-Zeit in Systemzeit");

		try {
			System.out.println("TIC-Zeit:    " + ticZeit);
			final long zeit = XMLTools.getTICDateTime(ticZeit);
			final GregorianCalendar cal = new GregorianCalendar();
			cal.setTimeInMillis(zeit);
			final DateFormat formatter = new SimpleDateFormat();
			System.out.println("Systemzeit:  " + formatter.format(cal.getTime()));
			Assert.assertEquals(cal.get(Calendar.HOUR), 10);
		} catch (final ParseException e) {
			e.printStackTrace();
			Assert.fail();
		}
	}

}
