/*
 * Segment 2 (KEx),  SWE 2.1 LMS
 * Copyright (C) 2007 BitCtrl Systems GmbH
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.kex.lms.empfang.dekoder;

import java.io.File;
import java.util.Collection;

import org.junit.Assert;
import org.junit.Test;

import de.bsvrz.dav.daf.main.config.ConfigurationArea;
import de.bsvrz.dav.daf.main.config.ConfigurationChangeException;
import de.bsvrz.dav.daf.main.config.ConfigurationObject;
import de.bsvrz.dav.daf.main.config.DataModel;
import de.bsvrz.dav.daf.main.config.DynamicObjectType;
import de.bsvrz.dav.daf.main.config.MutableSet;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.kex.lms.vew.RDSMeldung;
import de.bsvrz.kex.lms.vew.TestDav;
import de.bsvrz.kex.lms.vew.daten.RDSMeldungsDaten;

/**
 * Testcase f&uuml;r das Einlesen von TIC-Info Dateien.
 *
 * @author BitCtrl Systems GmbH, Gieseler
 */
public class TicDateiIT {

	/**
	 * Datenverteiler-Verbindung.
	 */
	TestDav dav = new TestDav();

	/**
	 * Testmethode Einlesen Datei.
	 */
	@Test
	public void testGetDocument() {
		// URL dateiurl =
		// ClassLoader.getSystemResource("de/bsvrz/kex/lms/empfang/dekoder/TICMeldungen.xml");

		// String testdatei = "C:\\TICMeldungen.xml";
		final String testdatei = "TICMeldungen.xml";

		Assert.assertTrue(dav.initDav());
		final SystemObject lms = dav.getDav().getDataModel().getObject("lmst.bw");

		final TICInfoDatei datei = new TICInfoDatei(new File(testdatei));
		try {
			final MutableSet meldungsmenge = ((ConfigurationObject) lms).getMutableSet("RDSMeldungen");

			final DataModel model = dav.getDav().getDataModel();
			final ConfigurationArea area = dav.getDav().getLocalConfigurationAuthority().getConfigurationArea();
			final Collection<RDSMeldungsDaten> meldungen = datei.bildeMeldungen();
			for (final RDSMeldungsDaten md : meldungen) {
				final String pid = md.bildePid();
				SystemObject so = model.getObject(pid);
				if (so == null) {
					System.out.println("neue Meldung " + pid + " wird angelegt");
					so = area.createDynamicObject((DynamicObjectType) model.getType("typ.rdsMeldung"), pid, pid);
					meldungsmenge.add(so);
				}

				final RDSMeldung rdsmeldung = new RDSMeldung(so, md);
				// md.setSystemobjekt(so);
				rdsmeldung.publiziereDAV(dav.getDav());
			}

		} catch (final TICInfoDateiException e) {
			// TODO Automatisch erstellter Catch-Block
			e.printStackTrace();
		} catch (final ConfigurationChangeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (final Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

}
