/*
 * Segment 2 (KEx),  SWE 2.1 LMS
 * Copyright (C) 2007 BitCtrl Systems GmbH
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.kex.lms.versand.kodierer;

import de.bsvrz.dav.daf.main.config.ConfigurationObject;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.kex.lms.vew.TestDav;
import de.bsvrz.sys.funclib.operatingMessage.MessageSender;
import junit.framework.TestCase;

/**
 * Testcase Kodierer-Modul.
 *
 * @author BitCtrl Systems GmbH, Gieseler
 */

public class KodiererIT extends TestCase {

	/**
	 * Datenverteiler-Verbindung.
	 */
	TestDav dav = new TestDav();

	/**
	 * Test method for
	 * {@link de.bsvrz.kex.lms.versand.kodierer.Meldungskodierer#run()}.
	 */
	public void testKodierer() {
		TestCase.assertTrue(dav.initDav());
		final SystemObject lms = dav.getDav().getDataModel().getObject("lmst.bw");
		MessageSender.getInstance().init(dav.getDav(), "LMS-Test", "LMS-Test");
		final Meldungskodierer mk = new Meldungskodierer(dav.getDav(), (ConfigurationObject) lms);

		while (true) {
			try {
				Thread.sleep(2000);
				if (!mk.isAlive()) {
					break;
				}
			} catch (final InterruptedException e1) {
				e1.printStackTrace();
			}
		}

	}
}
